/**
	jC limits standard library package
	
	@name   Limits (jC Standard Library)
	@brief  Reports on limits of numerical types
	@date   2010-12-1
	@author jbgarcia@uvigo.es
*/

var limits = ( function() {
    
    /// The maximum integer that can be stored
	var MaxInt = 2147483648;
	
	/// The minimum integer that can be stored
	var MinInt = -2147483649;

	/// The maximum double that can be stored
	var MaxDbl = Number.MAX_VALUE;

	/// The minimum double that can be stored
	var MinDbl = Number.MIN_VALUE;
	
	return {
		"MaxInt": MaxInt,
		"MinInt": MinInt,
		"MaxDbl": MaxDbl,
		"MinDbl": MinDbl,
	};
})();
