import java.lang.Math;

/**
    @name   Math (jC Standard Library)
    @brief  Common mathematical functions
    @date   2010-12-1
    @author jbgarcia@uvigo.es
*/


public class math {

/// The PI constant
public static final double PI = Math.PI;

/// The e constant
public static final double E = Math.E;

/**
	@brief Absolute value function
	@param x the value to apply this function
	@return the result of this function applied to x
*/

public static double abs(double x)
{
	return Math.abs( x );
}

/**
	@brief Absolute value function
	@param x the value to apply this function
	@return the result of this function applied to x
*/

public static int abs(int x)
{
	return Math.abs( x );
}

/**
	@brief Cosene function
	@param x the value to apply this function
	@return the result of this function applied to x
*/

public static double cos(double x)
{
	return Math.cos( x );
}

/**
	@brief Sine function
	@param x the value to apply this function
	@return the result of this function applied to x
*/

public static double sin(double x)
{
	return Math.sin( x );
}

/**
	@brief Arc cosene function
	@param x the value to apply this function
	@return the result of this function applied to x
*/

public static double acos(double x)
{
	return Math.acos( x );
}

/**
	@brief Arc sine function
	@param x the value to apply this function
	@return the result of this function applied to x
*/

public static double asin(double x)
{
	return Math.asin( x );
}

/**
	@brief Tangential function
	@param x the value to apply this function
	@return the result of this function applied to x
*/

public static double tan(double x)
{
	return Math.tan( x );
}

/**
	@brief Arc tangential function
	@param x the value to apply this function
	@return the result of this function applied to x
*/

public static double atan(double x)
{
	return Math.atan( x );
}

/**
	@brief Euler's number e raised to the power of x
	@param x the value to apply this function
	@return the result of this function applied to x
*/

public static double exp(double x)
{
	return Math.exp( x );
}

/**
	@brief Returns the natural logarithm (base e) of x
	@param x the value to apply this function
	@return the result of this function applied to x
*/

public static double log(double x)
{
	return Math.log( x );
}

/**
	@brief Returns the base 10 logarithm of x
	@param x the value to apply this function
	@return the result of this function applied to x
*/

public static double log10(double x)
{
	return Math.log10( x );
}

/**
	@brief Returns the integer number that is smaller than x
	@param x the value to apply this function
	@return the result of this function applied to x (as double)
*/

public static double floor(double x)
{
	return Math.floor( x );
}

/**
	@brief Returns the integer number that is bigger than x
	@param x the value to apply this function
	@return the result of this function applied to x (as double)
*/

public static double ceil(double x)
{
	return Math.ceil( x );
}

/**
	@brief Returns the a number x to the y-th power
	@param x the value to apply this function
	@param y the exponent
	@return the result of x^y
*/

public static double pow(double x, double y)
{
	return Math.pow( x, y );
}

/**
	@brief Returns the square root
	@param x the value to apply this function
	@return the result of square root of x
*/

public static double sqrt(double x)
{
	return Math.sqrt( x );
}

/**
	@brief Returns the closest integer value
	@param x the value to apply this function
	@return the result as int
*/

public static int round(double x)
{
	return (int) Math.round( x );
}

/**
	@brief Returns a number in the range [0, 1)
	@return a random number
*/
public static double random()
{
    return randomGenerator.nextDouble();
}

/**
 @brief Returns a number in the range [0, 1)
 @return a random number
 */
public static double rand()
{
    return random();
}

/**
 @brief Sets the seed of the random generator
 @param seed The new seed.
 */
public static void srand(int seed)
{
    randomGenerator.setSeed( (long) seed );
}

/**
	@brief Returns a conversion of x to degrees
	@param x the value to apply this function
	@return the result in degrees
*/

public static double toDegrees(double x)
{
	return Math.toDegrees( x );
}

/**
	@brief Returns the conversion of x to radians
	@param x the value to apply this function
	@return the result in degrees
*/

public static double toRadians(double x)
{
	return Math.toRadians( x );
}

private static java.util.Random randomGenerator = new java.util.Random();

} // class math  - jc Standard library
