// CompilingError.java
/**
 * Manage exceptions derived from compiling errors.
 */

package core;

import core.lexical.Position;

/**
 * Represents all possible errors related to compilation.
 * @author baltasarq
 */
public class CompilingError extends Exception
{
    public CompilingError(Position pos, String message)
    {
        super( message );

        StringBuilder toret = new StringBuilder();

        toret.append( pos.getFileName() );
        toret.append( ':' );
        toret.append( pos.getNumLine() );
        toret.append( ':' );
        toret.append( pos.getNumCharacter() );
        toret.append( ": " );

        this.prefixMessage = toret.toString();
    }

    @Override
    public String getMessage()
    {
        return this.prefixMessage + super.getMessage();
    }

    private String prefixMessage;
}
