// Cra.java

package core.bshbackend;

import core.intermediatecode.Instr;
import core.intermediatecode.types.ArrayType;

/**
 * Represents the creation of arrays in the Bsh backend
 * @author baltasarq
 */
public class Cra extends Opcode {
    
    public Cra(Instr instr)
    {
        super( instr );
    }

    @Override
    public core.intermediatecode.instrs.Cra getInstr()
    {
        return (core.intermediatecode.instrs.Cra) super.getInstr();
    }

    public String emit()
    {
        ArrayType arrayType = (ArrayType) this.getInstr().getType();
        StringBuilder toret = new StringBuilder();

        toret.append( "new ");
        toret.append( arrayType.getType().getJavaType().toString() );
        
        // Create dimensions
        for(int i = 0; i < arrayType.getDimensions(); ++i) {
            toret.append( '[' );
            toret.append( this.getInstr().getNumElems()[ i ].toString() );
            toret.append( ']' );
        }

        return toret.toString();
    }

}
