// Fin.java

package core.bshbackend;

import core.exceptions.SemanticError;
import core.intermediatecode.Instr;
import core.intermediatecode.Literal;
import core.intermediatecode.literals.ArrayLiteral;

/**
 * Represents literals for the BSH  backend
 * @author baltasarq
 */
public class Fin extends Opcode {

    public Fin(Instr instr)
    {
        super( instr );
    }

    @Override
    public core.intermediatecode.instrs.Fin getInstr()
    {
        return (core.intermediatecode.instrs.Fin) super.getInstr();
    }

    @Override
    public String emit() throws SemanticError {
        StringBuilder toret = new StringBuilder();
        Literal literal = this.getInstr().getLiteral();

        toret.append( Reserved.Final );
        toret.append( ' ' );
        toret.append( Reserved.getType( this.getInstr().getType() ) );
        toret.append( ' ' );
        toret.append( this.getInstr().getId().toString() );
        
        toret.append( Reserved.AssignOperator );
        
        toret.append( literal.toString() );
        if ( literal instanceof ArrayLiteral
         && ( (ArrayLiteral) literal ).isString() )
           
        {
                toret.append( ".toCharArray()" );
        }
        
        toret.append( Reserved.EndOfInstructionMark );
        return toret.toString();
    }

}
