/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package core.bshbackend;

import core.exceptions.SemanticError;
import core.intermediatecode.Instr;

/**
 *
 * @author baltasarq
 */
public class If extends Opcode
{

    public If(Instr instr)
    {
        super( instr );
    }

    @Override
    public core.intermediatecode.instrs.If getInstr()
    {
        return (core.intermediatecode.instrs.If) super.getInstr();
    }

    @Override
    public String emit() throws SemanticError {
        StringBuilder toret = new StringBuilder();

        if ( this.getInstr().getFirstCodeBlock().size() > 0
          || this.getInstr().getSecondCodeBlock().size() > 0 )
        {
            toret.append( Reserved.If );
            toret.append( '(' );
            toret.append( this.getInstr().getVar().toString() );
            toret.append( ")\n" );
            Opcode.generateBody( this.getInstr().getFirstCodeBlock(), toret );

            if ( this.getInstr().getSecondCodeBlock().size() > 0 ) {
                toret.append( Reserved.Else );
                Opcode.generateBody( this.getInstr().getSecondCodeBlock(), toret );
            }
        }

        return toret.toString();
    }

    
}
