/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package core.bshbackend;

import core.intermediatecode.types.BoolType;
import core.intermediatecode.types.CharType;
import core.intermediatecode.types.ArrayType;
import core.intermediatecode.Type;
import core.intermediatecode.types.DoubleType;
import core.intermediatecode.types.IntType;

/**
 *
 * @author baltasarq
 */
public class Reserved {
    // Marks
    public static final String CommentMark = "//";
    public static final String EndOfInstructionMark = ";";

    // Visibility
    public static final String Public = "public";
    public static final String Private = "private";

    // types
    public static final String Void = "void";
    public static final String Int = "int";
    public static final String Double = "double";
    public static final String Char = "char";
    public static final String Bool = "boolean";

    // Modifiers
    public static final String Final = "final";

    // Operators
    public static final String AssignOperator = "=";
    public static final String AddOperator = "+";
    public static final String SubOperator = "-";
    public static final String MulOperator = "*";
    public static final String DivOperator = "/";
    public static final String ModOperator = "%";
    public static final String NegOperator = "!";
    public static final String EqOperator = "==";
    public static final String NeqOperator = "!=";
    public static final String GtOperator = ">";
    public static final String LtOperator = "<";
    public static final String GteOperator = ">=";
    public static final String LteOperator = "<=";
    public static final String AndOperator = "&&";
    public static final String OrOperator = "||";

    // Satements
    public static final String While = "while";
    public static final String If = "if";
    public static final String Else = "else";
    public static final String Return = "return";
    public static final String Break = "break";
    public static final String Continue = "continue";

    /**
     * Return the appropriate label for the type
     * @param type The type object representing the wanted label.
     * @return The label, as a String object.
     */
    public static String getType(Type type)
    {
        String toret = Void;

        if ( type instanceof IntType ) {
            toret = Int;
        }
        else
        if ( type instanceof DoubleType ) {
            toret = Double;
        }
        else
        if ( type instanceof CharType ) {
            toret = Char;
        }
        else
        if ( type instanceof BoolType ) {
            toret = Bool;
        }
        else
        if ( type instanceof ArrayType ) {
            ArrayType arrayType = (ArrayType) type;

            // Get simple type part
            toret = Reserved.getType( arrayType.getType() );

            // Add dimensions
            toret += arrayType.getDimensionsAsString();
        }

        return toret;
    }
}
