// FileNotFound.java

package core.exceptions.semantic;

import core.I18n;
import core.exceptions.SemanticError;
import core.lexical.Position;

/**
 * Exception to be triggered when a file is not found
 * (normally, the user is the one to blame here)
 * @author baltasarq
 */
public class FileNotFound extends SemanticError {
    
    public FileNotFound(Position pos, String message)
    {
        super( pos, I18n.get( I18n.Sentence.FileError ) + ": " + message );
    }
}
