// IncorrectOpcode.java

package core.exceptions.semantic;

import core.I18n;
import core.bshbackend.Opcode;
import core.exceptions.SemanticError;
import core.lexical.Position;

/**
 * Exception to be triggered when, internally, the compiler does not find
 * the corresponding Opcode to Instr
 * @author baltasarq
 * @see Opcode, Instr
 */
public class IncorrectOpcode extends SemanticError {
    public IncorrectOpcode(Position pos, String message)
    {
        super( pos, I18n.get( I18n.Sentence.InvalidOpcode ) + ": " + message );
    }
}
