// Lib.java

package core.intermediatecode;

import core.CompilingError;
import java.io.File;

/**
 * Represents modules that are actually libraries
 * @author baltasarq
 */
public class Lib extends Module {

    public static final String LibraryPrefix = "lib_";

    public Lib(String prefix, File source)
    {
        super( source );
        this.prefix = prefix;
    }

    public String getCompleteName()
    {
        return ( this.prefix + '.' + this.getName() );
    }
    
    /**
     * Returns the prefix (i.e. the directory it lives in, such as "std")
     * @return The prefix of the library, as a String
     */
    public String getPrefix()
    {
        return this.prefix;
    }
    
    @Override
    public void chk() throws CompilingError
    {
        return;
    }

    @Override
    public String getDocFilePrefix() {
        return LibraryPrefix;
    }

    @Override
    public String getHtmlHeader()
    {
        return ( "&#8224; " + super.getHtmlHeader() );
    }
    
    private String prefix;
}
