/*
 * Parent class for all literals
 */

package core.intermediatecode;

import core.intermediatecode.Type;
import core.CompilingError;
import core.intermediatecode.RValue;
import core.lexical.Position;

/**
 * Parent class for all literals
 * @author baltasarq
 */
public abstract class Literal implements RValue {

    public abstract void setLiteral(String lit) throws CompilingError;
    public abstract void setLiteral(Object lit) throws CompilingError;
    public abstract Object getLiteral();
    
    @Override
    public abstract Type getType();

    public static Position getPos() {
        return new Position( "AST (literal)", 0, 0 );
    }
    
    @Override
    public abstract String toString();
    
    @Override
    public void chk()
    {
        return;
    }
}
