// Prg.java

package core.intermediatecode;

import java.io.File;

/**
 * Represents a program, i.e., a sequence of instr's
 * @see Instr
 * @author baltasarq
 */
public class Prg extends CodeUnit {

    public static final String ProgramPrefix = "prog_";
    public static final String ProgramFileExt = "jc";

    public Prg(File source)
    {
        super( source );
    }

    @Override
    public String getDocFilePrefix() {
        return ProgramPrefix;
    }

    @Override
    public CodeBlockOwner getOwner()
    {
        return null;
    }
    
    @Override
    public String getHtmlHeader()
    {
        return ( "<b>&#183;</b> " + super.getHtmlHeader() );
    }
}
