// Div.java

package core.intermediatecode.instrs;

import core.exceptions.syntax.IncorrectId;
import core.intermediatecode.RefId;
import core.lexical.Position;

/**
 * Division binary operator
 * @author baltasarq
 */
public class Div extends BinaryOp {
    public static final String Name = "DIV";

    public Div(Position pos, String op1, String op2) throws IncorrectId
    {
        this( pos, new RefId( pos, op1 ), new RefId( pos, op2 ) );
    }
    public Div(Position pos, RefId op1, RefId op2)
    {
        super( pos, op1, op2 );
    }

    @Override
    public String toString() {
        return Name + ' ' + super.toString();
    }
}
