/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package core.intermediatecode.instrs;

import core.intermediatecode.Type;
import core.CompilingError;
import core.intermediatecode.RefId;
import core.intermediatecode.types.BoolType;
import core.lexical.Position;
import core.lexical.Reserved;

/**
 * Represents logic operators under binary operators
 * @author baltasarq
 */
public class LogicBinaryOp extends BinaryOp
{
    /**
     * This is an intermediate class representing logic operators.
     * Operators must be comparable.
     * @param pos The position in the lexer
     * @param op1 The id for the first operand
     * @param op2 The id for the second operand
     */
    public LogicBinaryOp(Position pos, RefId op1, RefId op2)
    {
        super( pos, op1, op2 );
    }
    
    /**
     * Returns the type of the binary operator
     * In this case, the type is always boolean
     * @return BooleanType, the type of the 
     * @throws CompilingError 
     */
    @Override
    public Type getType() throws CompilingError
    {
        return BoolType.get();
    }
    
}
