/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package core.intermediatecode.instrs;

import core.intermediatecode.Type;
import core.CompilingError;
import core.intermediatecode.RefId;
import core.intermediatecode.types.BoolType;
import core.lexical.Position;

/**
 *
 * @author baltasarq
 */
public class LogicUnaryOp extends UnaryOp
{
    /**
     * This is an intermediate class representing logic operators.
     * Operators must be comparable.
     * @param pos The position in the lexer
     */
    public LogicUnaryOp(Position pos, RefId op)
    {
        super( pos, op );
    }
    
    /**
     * Returns the type of the binary operator
     * In this case, the type is always boolean
     * @return BooleanType, the type of the 
     * @throws CompilingError 
     */
    @Override
    public Type getType() throws CompilingError
    {
        return BoolType.get();
    }
}
