// Lt.java

package core.intermediatecode.instrs;

import core.exceptions.syntax.IncorrectId;
import core.intermediatecode.RefId;
import core.lexical.Position;

/**
 * Less than binary operator
 * @author baltasarq
 */
public class Lt extends LogicBinaryOp {
    public static String Name = "LT";

    public Lt(Position pos, String var1, String var2) throws IncorrectId
    {
        this( pos, new RefId( pos, var1 ), new RefId( pos, var2 ) );
    }

    public Lt(Position pos, RefId var1, RefId var2)
    {
        super( pos, var1, var2 );
    }

    @Override
    public String toString() {
        return ( Name + ' ' + super.toString() );
    }
}
