// Nop.java

package core.intermediatecode.instrs;

import core.intermediatecode.Type;
import core.CompilingError;
import core.exceptions.SemanticError;
import core.intermediatecode.Instr;
import core.lexical.Position;
import core.I18n;

/**
 * Represents the no operation
 * @author baltasarq
 */
public class Nop extends Instr {
    public static final String Name = "NOP";
    
    public Nop(Position pos)
    {
        super( pos );
    }
    
    @Override
    public String toString()
    {
        return Name;
    }

    @Override
    public Type getType() throws CompilingError
    {
        throw new CompilingError( this.getPosition(),
                "jcg.Nop.getType(): " + I18n.get( I18n.Word.Type ) + '?' );
    }
    
    @Override
    public void chk() throws SemanticError, CompilingError
    {
       super.chk();
    }
    
}
