/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package core.intermediatecode.instrs;

import core.intermediatecode.Data;
import core.intermediatecode.Type;
import core.CompilingError;
import core.exceptions.SemanticError;
import core.Ast;
import core.intermediatecode.RefId;
import core.intermediatecode.types.BoolType;
import core.intermediatecode.types.NumericalType;
import core.lexical.Position;
import core.I18n;

/**
 *
 * @author baltasarq
 */
public abstract class UnaryOp extends Op {

    public UnaryOp(Position pos, RefId var)
    {
        super( pos, 1 );

        this.ops[ 0 ] = var;
    }

    public RefId getOp()
    {
        return this.getOps()[ 0 ];
    }

    @Override
    public void chk() throws CompilingError
    {
        Data vop1 = Ast.getAst().locateData( this.getPosition(), this.getOwner(), this.getOp() );

        // Chk operand
        if ( vop1 == null ) {
            throw new SemanticError( this.getPosition(), I18n.get( I18n.Word.Unexpected )
                    + "opr.: '" + this.getOp().getId() + '\''
            );
        }

        // Chk operand type
        Type top1 = vop1.getType();
        if ( !( this instanceof LogicUnaryOp ) ) {
            if ( !( top1 instanceof NumericalType ) ) {
                throw new SemanticError( this.getPosition(), I18n.get( I18n.Word.Unexpected )
                        + " opr. " + I18n.get( I18n.Word.For )
                        + ' ' + I18n.get( I18n.Word.Type )
                        + ": " + top1.toString()
                );
            }
        } else {
            if ( !( top1 instanceof BoolType ) ) {
                throw new SemanticError( this.getPosition(), I18n.get( I18n.Word.Expected )
                        + BoolType.Name
                );
            }
        }
    }

    @Override
    public Type getType() throws CompilingError
    {
        Data vop1 = Ast.getAst().locateData( this.getPosition(), this.getOwner(), this.getOp() );

        if ( vop1 == null ) {
            throw new SemanticError( this.getPosition(), I18n.get( I18n.Word.Missing )
                    + ": '" + this.getOp().getId() + '\''
            );
        }
        
        return vop1.getType();
    }

}
