// IntLiteral.java

package core.intermediatecode.literals;

import core.exceptions.SemanticError;
import core.I18n;
import core.intermediatecode.types.IntType;

/**
 *
 * @author baltasarq
 */
public class IntLiteral extends NumericalLiteral {
    public IntLiteral(int lit)
    {
        this.lit = lit;
    }

    @Override
    public String toString()
    {
        return Integer.toString( this.lit );
    }

    @Override
    public void setLiteral(String lit)
    {
        this.lit = Integer.parseInt( lit );
    }

    @Override
    public void setLiteral(Object lit) throws SemanticError
    {
        if (  lit.getClass() != Integer.class ) {
            throw new SemanticError( getPos(), "jcg.Int.setLiteral(): "
                    + I18n.get( I18n.Word.Expected )
                    + ' ' + IntType.Name
            );
        }
        
        this.lit = (Integer) lit;
    }

    @Override
    public Integer getLiteral()
    {
        return this.lit;
    }

    @Override
    public IntType getType()
    {
        return IntType.get();
    }

    private int lit;
}
