// AnyType.java

package core.intermediatecode.types;

import core.intermediatecode.Type;

/**
 * The infinite union of all types.
 * @author baltasarq
 */
public class AnyType extends Type {
    public static final String Name = "any";

    private AnyType()
    {
    }

    public static AnyType get()
    {
        if ( instance == null ) {
            instance = new AnyType();
        }

        return instance;
    }

    @Override
    public String toString() {
        return Name;
    }

    @Override
    public Class getJavaType() {
        return Object.class;
    }
    
    private static AnyType instance;
}
