// PublicVisibility.java

package core.intermediatecode.visibilities;

/**
 * Public visibility: members marked with this can be referenced.
 * @author baltasarq
 */
public final class PublicVisibility extends Visibility {
    public static final String Name = "pub";

    private PublicVisibility()
    {
    }

    public static PublicVisibility get()
    {
        if ( instance == null ) {
            instance = new PublicVisibility();
        }

        return instance;
    }

    @Override
    public String toString()
    {
        return Name;
    }

    private static PublicVisibility instance = null;
}
