// Acc.java
/*
    Vector access
*/


package core.jsbackend;

import core.exceptions.SemanticError;
import core.intermediatecode.Instr;

/**
 * Backend equivalent for Vector Access
 * @author baltasarq
 */
public class Acc extends Opcode {

    public Acc(Instr instr)
    {
        super( instr );
    }

    @Override
    public core.intermediatecode.instrs.Acc getInstr()
    {
        return (core.intermediatecode.instrs.Acc) super.getInstr();
    }

    @Override
    public String emit() throws SemanticError {
       StringBuilder toret = new StringBuilder();

        toret.append( this.getInstr().getId() );

        for(int i = 0; i < this.getInstr().getDimensionsNeeded(); ++i) {
            toret.append( '[' );
            toret.append( this.getInstr().getElementPosition()[ i ].toString() );
            toret.append( ']' );
        }

        return toret.toString();
    }

}
