// BinaryOp.java

package core.jsbackend;

import core.exceptions.SemanticError;
import core.intermediatecode.Instr;
import core.intermediatecode.instrs.*;

/**
 *
 * @author baltasarq
 */
public class BinaryOp extends Opcode {

    public BinaryOp(Instr instr)
    {
        super( instr );
    }

    @Override
    public core.intermediatecode.instrs.BinaryOp getInstr()
    {
        return (core.intermediatecode.instrs.BinaryOp) super.getInstr();
    }

    public String emit() throws SemanticError
    {
        StringBuilder toret = new StringBuilder();

        toret.append( '(' );
        toret.append( this.getInstr().getOp1().toString() );

        if ( this.getInstr() instanceof Add ) {
            toret.append( Reserved.AddOperator );
        }
        else
        if ( this.getInstr() instanceof Sub ) {
            toret.append( Reserved.SubOperator );
        }
        else
        if ( this.getInstr() instanceof Mul ) {
            toret.append( Reserved.MulOperator );
        }
        else
        if ( this.getInstr() instanceof Div ) {
            toret.append( Reserved.DivOperator );
        }
        else
        if ( this.getInstr() instanceof Mod ) {
            toret.append( Reserved.ModOperator );
        }
        else
        if ( this.getInstr() instanceof Eq ) {
            toret.append( Reserved.EqOperator );
        }
        else
        if ( this.getInstr() instanceof Neq ) {
            toret.append( Reserved.NeqOperator );
        }
        else
        if ( this.getInstr() instanceof Gt ) {
            toret.append( Reserved.GtOperator );
        }
        else
        if ( this.getInstr() instanceof Lt ) {
            toret.append( Reserved.LtOperator );
        }
        else
        if ( this.getInstr() instanceof Gte ) {
            toret.append( Reserved.GteOperator );
        }
        else
        if ( this.getInstr() instanceof Lte ) {
            toret.append( Reserved.LteOperator );
        }
        else
        if ( this.getInstr() instanceof And ) {
            toret.append( Reserved.AndOperator );
        }
        else
        if ( this.getInstr() instanceof Or ) {
            toret.append( Reserved.OrOperator );
        }
        else {
            throw new SemanticError( Opcode.getPos(), "jcg.BinaryOp.emit(): opr?" );
        }

        toret.append( this.getInstr().getOp2().toString() );
        toret.append( ')' );
        
        return toret.toString();
    }
}
