// Fin.java

package core.jsbackend;

import core.exceptions.SemanticError;
import core.intermediatecode.Instr;
import core.intermediatecode.Literal;

/**
 * Opcode for constants
 * @author baltasarq
 */
public class Fin extends Opcode {

    public Fin(Instr instr)
    {
        super( instr );
    }

    @Override
    public core.intermediatecode.instrs.Fin getInstr()
    {
        return (core.intermediatecode.instrs.Fin) super.getInstr();
    }

    @Override
    public String emit() throws SemanticError
    {
        StringBuilder toret = new StringBuilder();
        Literal literal = this.getInstr().getLiteral();

        toret.append( Reserved.VariableMark );
        toret.append( ' ' );
        toret.append( this.getInstr().getId().toString() );
        
        toret.append( Reserved.AssignOperator );
        
        toret.append( literal.toString() );
        toret.append( Reserved.EndOfInstructionMark );
        return toret.toString();
    }

}
