// UsrId.java

package core.lexical;

import core.I18n;
import core.exceptions.syntax.IncorrectId;

/**
 *
 * @author baltasarq
 */
public class UsrId extends Id {
    
    public UsrId(String strId, Position pos) throws IncorrectId
    {
        super( strId, pos );
    }
    
    /**
    * This is an id created by the user. This id cannot have
    * the same prefixes as the id's generated by the jc compiler, or
    * those id's could clash.
    * @throws IncorrectId
    */
    @Override
    public void chk() throws IncorrectId
    {
        super.chk();
        String strId = this.getId();
        
        if ( strId.startsWith( Id.TmpId ) ) {
            throw new IncorrectId( this.getPos(), I18n.get( I18n.Word.Prefix )
                    + I18n.get( I18n.Word.Prohibited )
                    + ": '" + strId + '\''
            );
        }
        
        return;
    }

}
